#define version "F1FWG.13"
/*
  Fréquencemètre réel : problème de compatibilité de <FreqCounter.h> avec <Time.h> !!! ???
  tone  et noTone mis en ///
  
  
  Voltmètre U1 U2 U3
  Morse
  GBF
  Fréquencemètre, capacimètre, selfmètre : simulés
  ---
  Modes et menu général
  Clavier analogique à diodes et debug
  LCD
  Gestion du temps
  Compactage des sorties série (intégration d'une bibliothèque : Streaming)
  GRAFCET
  TEMPORISATION basique
  FRONT MONTANT/DESCENDANT
*/
//**********************************************************
// BIBLIOTHEQUES
// incluses dans le package Arduino de base
#include <LiquidCrystal.h>  // LCD

// ajoutées
#include <Streaming.h>
#include <Time.h>

/*
  Martin Nawrath KHM LAB3
  Kunsthochschule f¸r Medien Kˆln
  Academy of Media Arts
  http://www.khm.de
  http://interface.khm.de/index.php/labor/experimente/	
  http://interface.khm.de/index.php/lab/experiments/arduino-frequency-counter-library/
  NB : l'entrée de comptage est le D5
*/
#include <FreqCounter.h>

// DEBUG : 0=pas de debug, valeur selon besoins
#define debug 0

//**********************************************************
// DECLARATIONS
// LCD initialize the library with the numbers of the interface pins
/* Câblage du LCD
 * LCD pin 1 to GND
 * LCD pin 2 to VCC 5V
 * LCD pin 3 : contraste sur le point milieu d'un potentiomètre de 10K entre le GND et le VCC (réglé très près de la masse)
 * LCD pin 4 RS to digital pin 4
 * LCD pin 5 RW to GND
 * LCD pin 6 Enable pin to digital pin 2
 * LCD pin 11 D4 pin to digital pin 6
 * LCD pin 12 D5 pin to digital pin 7
 * LCD pin 13 D6 pin to digital pin 8
 * LCD pin 14 D7 pin to digital pin 9
*/
//  LiquidCrystal lcd(RS, Enable,  D4, D5, D6, D7)
  LiquidCrystal lcd(4, 2, 6, 7, 8, 9);

// entrées-sorties
#define led_a 13
#define sortie_gbf 3

// temporisations
int tempo_a,tempo_b;
// vitesse de clignotement : maintenant en millisecondes
int tempo_a_reset=1000;
int tempo_b_reset=700;
// gestion du temps
int previousSecond;      // secondes de l'horloge
int top_dixieme=false;   // top pour traitements au 1/10 seconde dans le P/P
int top_seconde=false;   // top pour traitements à la seconde dans le P/P
int top_minute=false;   // top pour traitements à la minute dans le P/P
unsigned long previousMillis, previousDecis;
char* jours[] = {"Sam","Dim","Lun","Mar","Mer","Jeu","Ven"} ;
// clavier à 16 touches et diodes sur entrée analogique
#define clavier A0
int itouche,itouche1=-1,itouche2=-1,vtouche,ntouche,tempo_repeat;
int itouche3=-1,itouche4=-1;
// touche renvoyée
char touche=' ',touche_repeat=' ';

// CLAVIER 10 TOUCHES A DIODES 0,2V
int nbtouche = 10;
// caractère touche renvoyée
//                 <----------------clavier-10 touches------------>                16 touches--->                          24 touches--->
char ltouche[] =  {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ' '};        // nbtouche
// valeurs analogiques. A ajuster selon valeurs relevées après montage # 41 pour 0,2 Volts/diode
int xtouche[] =   {  0,  45,  90, 136, 181, 226, 270, 313, 354, 396, 437, 1023};  // nbtouche+1

/*
// CLAVIER 24 TOUCHES A DIODES 0,2V
int nbtouche = 24;
// caractère touche renvoyée
//                 <----------------clavier-10 touches------------>                16 touches--->                          24 touches--->
char ltouche[] =  {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', ' '};        // nbtouche
// valeurs analogiques. A ajuster selon valeurs relevées après montage # 41 pour 0,2 Volts/diode
int xtouche[] =   {  0,  45,  91, 136, 181, 226, 270, 313, 354, 396, 437, 478, 519, 560, 601, 642, 683, 724, 765, 806, 847, 888, 929, 970, 1010, 1023};  // nbtouche+1
*/

// speedomètre = calcul de vitesse ...
unsigned int tours_ps,tours,tours_led;

// GRAFCETS
int grafcet_a=10;
int grafcet_b=0;

// definition des modes de fonctionnement correspondant aux différentes fonctions possibles
#define modemax 13
int mode=0,modeav=modemax,modeap=1;
static char* modex[]={"Horl","Freq", "Lslf", "Capa", "Volt", "GBF_","PWM_","Srvo","Acco","Baro","Ther","Reve","Kafe","Mors"};
//                      0      1      2        3       4       5      6      7      8      9       10    11     12     13    14   15    16
static char* menus[]={" --  ++  Ok  Ok ","-vit+ O 1 Pitch"," --  -    +  ++ "};
//             0=général          1=morse          2=GBF

// variables très locales !
int i;
char valuef[15],valueff[15],valuefff[15];    // pour sorties du S/P formatf

// Constantes sympas avec une précision suffisante (Arduino gère 7 à 8 decimales)
#define deuxpi  6.283185307 //179586476925286766559;  // à peu près 2 Pi
#define racine2 1.414213562 //3730950488016887242097; // racine carree de 2
#define demiton 1.059463094 //3592952645618252949463; // 2 puissance 1/12 rapport de fréquence entre 2 notes 

// FREQUENCES, CAPAS, SELFS
float self,self0,capa,capa0,freq,freq0;
// fréquencemetre
int gatetime=100;
int grafcet_frequencemetre=0;

// VOLTmetre
#define entree_U1 A1
#define entree_U2 A2
#define entree_U3 A3
float U1,U2,U3;

/////////////// Simple Arduino CW //////////////////
// Written by Mark VandeWettering K6HX
// Email: k...@arrl.net
//
// Thx Mark de ON7EQ !
// http://www.qsl.net/on7eq/en/index.htm
/*
Codage très astucieux !!!
Les patterns sont faits comme suit :
 - Lecture de droite à gauche 
 - bit = 0 = . dit
 - bit à 1 = - dash
 - on rajoute un bit à 1 pour finir
Lecture : 
a/ on fait d'abord p=morsetab[i].pat 
b/ si p = 1 on Arrête
c/ si le bit de poids faible de p (à droite) = 1 = dash = trait
d/ si le bit de poids faible de p(à droite) = 0 = dot = point
e/ on divise p par 2, c'est à dire on shifte à droite de 1 bit, et on retourne en b/
exemples :
	{'C', 21},  // -.-. 0001 0101
  0001 010 1 = dash
  0000 101 0 = dot
  0000 010 1 = dash
  0000 001 0 = dot
  0000 000 1 = 1 = STOP
	{'Q', 27},	// --.- 0001 1011
  0001 101 1 = dash
  0000 110 1 = dash
  0000 011 0 = dot
  0000 001 1 = dash
  0000 000 1 = 1 = STOP
... F1FWG
*/
struct t_mtab { char c, pat; } ;
struct t_mtab morsetab[] = {
  	{'.', 106},    // -.-.-. 0110 1010
	{',', 115},    // --..-- 0111 0011
	{'?', 76},
	{'/', 41},
	{'A', 6},	// -.	0000 0110
	{'B', 17},
	{'C', 21},	// -.-.	0001 0101
	{'D', 9},
	{'E', 2},
	{'F', 20},
	{'G', 11},
	{'H', 16},
	{'I', 4},
	{'J', 30},
	{'K', 13},	// _._	0000 1101
	{'L', 18},
	{'M', 7},	// --	0000 111
	{'N', 5},
	{'O', 15},
	{'P', 22},
	{'Q', 27},	// --.-	0001 1011
	{'R', 10},  // ._.	0000 1010
	{'S', 8},
	{'T', 3},	// _	0000 0011
	{'U', 12},
	{'V', 24},	// ...-	0001 1000
	{'W', 14},
	{'X', 25},
	{'Y', 29},
	{'Z', 19},
	{'1', 62},	// -....	0011 1110
	{'2', 60},
	{'3', 56},
	{'4', 48},
	{'5', 32},
	{'6', 33},
	{'7', 35},
	{'8', 39},
	{'9', 47},     // ----. 0010 1111
	{'0', 63}      // ----- 0011 1111
        } ;

#define CW_N_MORSE  (sizeof(morsetab)/sizeof(morsetab[0]))
int CW_PITCH=700; // frequence
//#define CW_SPEED  (18)		// mots/minute
int CW_SPEED=12;		// mots/minute
int CW_DOTLEN;
int CW_DASHLEN;  // CW weight original 3.5 / 1

int grafcet_cw=1;    // armé en attente à priori
int tempo_cw, tempo_attcw, tempo_attcwval=2000;
char cw, pw;    // caractère en cours, et bits en cours
int  cw_pos; // position en cours d'émission dans le buffer 'cw_texte'
char cw_texte[15];
char cw_texte_att[15],cw_texte_old[15];

////////// end CW section ////////////

//**********************************************************
// INITIALISATIONS
void setup() {
// initialize the pins
  pinMode(led_a, OUTPUT);
  pinMode(sortie_gbf, OUTPUT);
  pinMode(clavier, INPUT);
  digitalWrite(clavier,HIGH);    // résistance de pullup

  pinMode(entree_U1, INPUT);
  pinMode(entree_U2, INPUT);
  pinMode(entree_U3, INPUT);

// définition taille du LCD :
  lcd.begin(16, 2);

// mise à l'heure
  setTime(00,00,00,25,12,13); // 00h00 le 25 déc 2013 setupArduinoTime(2013,25,21,12,15,00));

// ligne série (pour traces)
  Serial.begin(9600);  // ou 9600 selon votre port COM
#if debug > 0  
  Serial << "Serial ok" << endl;
#endif

// fréquencemetre
//  FreqCounter::f_comp=0;   // Cal Value / Calibrate with professional Freq Counter

// BIP de Start
  strncpy(cw_texte,"$\0",2);  // Bip
  
} // Fin du SETUP
//**********************************************************
// PROGRAMME PRINCIPAL
void loop() {

// compte-tours par seconde et led_a "heart-beat" commutée
  if (tours < 65535) tours++;
  tours_led++;
  if (tours_led > 10000) { tours_led = 0 ;  digitalWrite(led_a, !digitalRead(led_a)); } 
  
// gestion du temps (dont temporisations)
  ger_top_centieme ();
  
// opérations à chaque dixième de seconde
  if (top_dixieme) {
    top_dixieme = false;
  }
 
// opérations à chaque seconde
  if (top_seconde) {
    top_seconde = false;
    tours_ps=tours; tours=0;
  }

// vitesse CW
  CW_DOTLEN=1200/CW_SPEED;
  CW_DASHLEN=3.5*CW_DOTLEN;

//--------------------------------********************--------------------------------
switch (grafcet_a) {

//--------------------------------
// mode horloge basique
  case 0:
      strncpy(cw_texte,"$\0",2);  // Bip
      lcd.clear(); lcd.setCursor(0, 1); lcd << "Menu " << version;
      grafcet_a++;
  break;
  
  case 1:
// appel menu général
    if (touche != ' ') {
      grafcet_a = 10;
      touche = ' '; 
    }
// horloge de base
    if (tempo_a == 0) {
      tempo_a = 1000;
      horodatage_serial(); Serial << " top" << tours_ps << "t/s    " << grafcet_a << " " << grafcet_b << endl;
      lcd.setCursor(0, 0);
      if (second()%10 > 7) {
//         lcd << dayStr(weekday()) << " " << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year();
         lcd << " " << jours[weekday()] << " " << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year() << " " ;
      } else {
//         lcd << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << "  " << ((tours_ps<1000)?" ":"")  << tours_ps;
         lcd << "  " << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << "   GER";
      }
    }
  break;

//--------------------------------
/* MODES : on arme le grafcet à mode*100
mode - fonction
 0 - horloge basique
 1 - fréquencemètre (8 Mhz à priori, c'est facile le selfmètre capacimètre en est un)
 2 - un selfmètre capacimètre (c'est l'idée de départ) ???
 3 - capacimètre
 4 - un multi-voltmètre 20 Volts, ampèremètre éventuel (détecteur à faire, mais je connais l'astuce) ???
 5 - un GBF (ce que peut faire l'Arduino, sans doute jusque vers 30 kHz)
 6 - mais aussi générateur de signal pour tester des servo moteurs de télécommande ???
 7 - et encore générateur de commande PWM ???
 8 - un accordeur de guitare ou autre bombarde (quand j'aurais connecté un HP) ???
 9 - un baro-thermomètre à base de BMP085 (bus I2C sur A4+A5) ???
 10 - un appareil de mesure de capacité isolante d'un mur (avec 3 capteurs DS1820 bus 1 fil sur A5) ???
 11 - horloge réveil temporisation ( synchro avec horloge temps réel DS1307 ou horloge radio DFM77 ??? )
 12 - pas le café, quoi que ... 
 13 - la gestion du Morse (indicateur sonore)
 - une alimentation 5V et 12 V pour bidouiller 
*/
//--------------------------------
// mode par défaut, attente de choix d'un mode
  case 10:
//  affichage menu déroulant horizontal
    modeav = ((mode>0)?mode-1:modemax);
    modeap = ((mode<modemax)?mode+1:0);
// ou plus simplement (mais 4 octets de plus !!!) :   if (mode < modemax ) { modeap = mode+1; } else { modeap = 0; }
    lcd.setCursor(0, 0);  lcd << modex[modeav] << " <" << modex[mode] << "> " << modex[modeap] ; 
    lcd.setCursor(0, 1);  lcd << menus[0]; 
    grafcet_a++;
    tempo_a = 15000; // on arme la tempo, si on n'a pas choisi avant la fin, on passe en horloge
    strncpy ( cw_texte_att, modex[mode], 1 ); // on récupère que le 1er caractère
  break;

  case 11:  
// envoi en CW de l'option affichée
//    if (tempo_attcw == 0) strcpy(cw_texte,modex[mode]);
// retour à l'horloge
    if (tempo_a == 0) { grafcet_a = 0; }
// - sans répétition
    if (touche == '3') {
      mode = modeav; 
      grafcet_a = 10;
      touche = ' ';
// annonce option en Morse
//      strcpy(cw_texte,modex[mode]);
      strncpy ( cw_texte_att,modex[mode], 1 ); 
    }
// + avec répétition
    if (touche_repeat == '4') {
      mode = modeap; 
      grafcet_a = 10;
      touche_repeat = ' ';
// annonce option en Morse
//      strcpy(cw_texte,modex[mode]);
      strncpy ( cw_texte_att,modex[mode], 1 ); 
    }
// Ok
    if (touche != ' ' and touche != '4') {    // 3 est exclue du fait que traitée avant !
//      strcpy(cw_texte,"OK");
      strncpy ( cw_texte,modex[mode], 1 ); 
      grafcet_a = 100*mode;
      tempo_a = 0;
// debug      lcd.setCursor(0, 1);  lcd << "mod=" << mode << " gr=" << grafcet_a; delay(1000);
      Serial << modex[mode] << endl;
      lcd.clear(); touche_repeat = ' '; touche = ' ';
    }
  break;

//--------------------------------
// Frequencemetre
  case 100:
    if (touche == '9') {
//      formatf(freq,'c',7,valueff);
      strcpy(cw_texte,valueff);
      lcd.setCursor(0, 1);  lcd << valueff;
      touche = ' ';
    }
    if (touche == '0') {
      grafcet_frequencemetre = 9999; // Arrêt du fréquencemètre
      touche = ' ';
      grafcet_a=9999;    // pour raz grafcet
    }
    if (tempo_a == 0) { tempo_a=100; grafcet_a++;}
  break;

  case 101:
    if (grafcet_frequencemetre < 2) {
      lcd.setCursor(0, 1);  lcd << "   ";  // conversion démarre
      grafcet_frequencemetre = 2; // démarrage du fréquencemètre
      grafcet_a++;               // et on passe à l'étape suivante
//    freq = 144612500.;        // simulation
      tempo_a = 100+gatetime;
    }
    if (tempo_a == 0 || touche != ' ') { grafcet_a=100;}
  break;

  case 102:
    if (grafcet_frequencemetre == 1) {      // conversion terminée
      lcd.setCursor(0, 1);  lcd << "***";  // conversion OK
//    freq += 0.001*millis();
      formatf(freq,'c',7,valueff);
      lcd.setCursor(0, 0);  lcd << modex[mode] << "=" << valueff;
      Serial << modex[mode] << "=" << valueff  << endl;
      tempo_a = 100;             // on arme la tempo
      grafcet_a=100;
    }
    if (tempo_a == 0 || touche != ' ') { grafcet_a=100;}
  break;

    
//--------------------------------
// Selfmetre - Capacimètre
/*
FORMULES de BASE des circuits oscillants
  1(un)=LCw²
  F=2*Pi*w
  1=L*C*(2Pi*F)²
  L=1/(C*(2Pi*F)²)
  C=1/(L*(2Pi*F)²)
  F=Racine(1/L*C)/2*Pi

Voir aussi Wikipedia : http://fr.wikipedia.org/wiki/Circuit_LC
*/
  case 200:
  case 300:
    self=0.000068;          // 68 uH
    capa=0.000000000680;    // 680 pF
    grafcet_a++;               // et on passe à l'étape suivante
//    if (grafcet_frequencemetre ==0) grafcet_frequencemetre = 1; // démarrage du fréquencemètre
//    self = self0; capa = capa0; // pour simulation
  break;

  case 201:
  case 301:
    lcd.setCursor(0, 0);  lcd << modex[mode] << "=" ; 
    Serial << modex[mode] << " " ; 
// Capacimètre
    if (grafcet_a > 250) { 
//      x = 1. / (self * pow(deuxpi * freq, 2.));    // C = 1 / (L * (2 * Pi * F)²) 
//    capa = x-capa0;
      capa *= 1.41421356;
      formatf(capa,'F',4,valueff);
      formatf(self,'H',4,valuef);
      lcd << valueff;
      lcd.setCursor(0, 1); lcd << valuef;
      Serial << " " << valueff << " " << valuef; 

// Selfmetre
    } else { 
//      x = 1. / (capa * pow(deuxpi * freq, 2.));    // L = 1 / (C * (2 * Pi * F)²) 
//      self = x-self0;
        self *= 1.41421356;
      formatf(self,'H',4,valueff);
      formatf(capa,'F',4,valuef);
      lcd << valueff;
      lcd.setCursor(0, 1); lcd << valuef;
      Serial << " " << valueff << " " << valuef; 
    }
 // calcule la fréquence de résonnance   
    freq = 1. / (deuxpi * pow(self*capa,0.5));    // F = 1 / (2 * Pi * racine_carree ( L * C ))
    formatf(freq,'c',4,valuef);
    Serial << " " << valuef << endl;
    lcd << " " << valuef;
    tempo_a = 2500;             // on arme la tempo
    grafcet_a++;               // et on passe à l'étape suivante
    if (capa > 0.000000680 or self > 0.068 ) grafcet_a-=2;
  break;

  case 202:
  case 302:
    if (touche == '0') {
      touche = ' ';
//    grafcet_frequencemetre = 9999; // Arrêt du fréquencemètre
      grafcet_a=9999;    // pour raz grafcet
    }
    if (touche == '1') {
      self=0.01-self;
      capa=0.0000001-capa;
      grafcet_a--;
      touche = ' ';
    }
// morse à la demande
    if (touche == '9') {
//      formatf(freq,'c',7,valueff);
      strcpy(cw_texte,valueff);
      touche = ' ';
    }
    if (tempo_a == 0) grafcet_a--;
  break;


//--------------------------------
// VOLTmetre
  case 400:
    if (tempo_a == 0) {
      tempo_a = 333;
      U1 = 0.02 * analogRead(entree_U1);
      formatf(U1,'V',4,valuef);
      lcd.setCursor(0, 0);  lcd << modex[mode] << "    " << valuef;
      horodatage_serial(); Serial << modex[mode] << " U1=" << valuef; 
 
      U2 = 0.02 * analogRead(entree_U2);
      U3 = 0.02 * analogRead(entree_U3);
      formatf(U2,'V',4,valueff);
      formatf(U3,'V',4,valuefff);
      lcd.setCursor(0, 1); lcd << valueff << " " << valuefff;
      Serial << " U2=" <<  valueff << " U3=" << valuefff << endl;
    }
// U3
    if (touche == '9') {
      strcpy(cw_texte,valuef);
      tempo_a = 10000;
      touche = ' ';
    }
// U2
    if (touche == '8') {
      strcpy(cw_texte,valueff);
      tempo_a = 10000;
      touche = ' ';
    }
// U1
    if (touche == '7') {
      strcpy(cw_texte,valuefff);
      tempo_a = 10000;
      touche = ' ';
    }
// sortie VOLTmetre
    if (touche != ' ') {
      touche = ' ';
      grafcet_a=9999;    // pour raz grafcet
    }
    break;
  
//--------------------------------
// GBF
  case 500:
    freq=880.000; // Hertz
//  pwm = 127;
//  servo = 90;
    grafcet_a++;               // et on passe à l'étape suivante
  break;

  case 501:
    if (freq < 1.) freq=1.;
    if (freq > 50000.) freq=50000.;
    formatf(freq,'c',5,valuef);
    Serial << modex[mode] << " F=" << valuef; 
    lcd.setCursor(0, 0);  lcd << modex[mode] << " F=" << valuef;
    lcd.setCursor(0, 1);  lcd << menus[2]; 

// GBF
//    tone(sortie_gbf, (unsigned int) freq); // ms
// PWM
//    analogWrite(0-255) 
// Servo
//  myservo.attach(sortie_GBF);
//  myservo.write(90);  // 0-180 set servo to mid-point

    tempo_a = 200;
    grafcet_a++;               // et on passe à l'étape suivante
  break;
  
  case 502:
    if (touche == '0') {
//      noTone(sortie_gbf); 
      touche = ' ';
      grafcet_a=9999;    // pour raz grafcet
    }
    if (touche == '1') freq = 440.;
    if (touche == '2') freq = 880.;
    if (touche == '3') freq /= racine2;
    if (touche_repeat == '4') { freq /= demiton; touche_repeat = ' '; }
    if (touche_repeat == '5') { freq *= demiton; touche_repeat = ' '; }
    if (touche == '6') freq *= racine2;
    if (touche == '7') freq = 1760.;
    if (touche == '8') freq = 3520.;
    if (touche == '9') freq = 7040.;
    if (touche != ' ') { grafcet_a--;  touche = ' '; }
    if (tempo_a == 0) grafcet_a--;
  break;

//--------------------------------
// Café (en fait, bidouille)

  case 1200:
    i=0;
    grafcet_b=1;
    grafcet_a++;
  break;

  case 1201:
// chenillard
    lcd.setCursor(i, 0);  lcd << " "; 
    i++; if (i>15) i=0;
    lcd.setCursor(i, 0);  lcd << "*"; 
// 2 grafcets
    lcd.setCursor(0, 1); lcd << grafcet_a << "ab" << grafcet_b << "    ";
    lcd.setCursor(11, 1); lcd << tours_ps << "   ";
    tempo_a = 500;             // on arme la tempo
    grafcet_a++;
  break;

  case 1202:
    if (touche == '0') {
      touche = ' ';
      grafcet_b=0;
      grafcet_a=9999;    // pour raz grafcet
    }
    if (tempo_a == 0) grafcet_a=1201;
  break;   
//--------------------------------
// Gestion du Morse : sortie sur sortie GBF
//  la génération même du Morse est faite dans un autre grafcet (grafcet_cw), 
//  car elle est simultanée et indépendante du reste !
  case 1300:
    lcd.setCursor(0, 0); lcd << "Vit=" << CW_SPEED << " Ptch=" << CW_PITCH << "  ";
    lcd.setCursor(0, 1); lcd << menus[1]; 

    tempo_a=200;
    if (grafcet_cw == 0) grafcet_cw = 1;
    grafcet_a++;
  case 1301:
    if (touche != ' ') {
//                                        123456789012345
      if (touche == '1') strcpy(cw_texte,"CQ CQ DE F1FWG\0");    // message test (maxi 15 car)
      if (touche == '2') strcpy(cw_texte_att,"Volt\0");           // message test différé
      if (touche == '3') CW_SPEED --;
      if (touche == '4') CW_SPEED ++;
      if (touche == '5') grafcet_cw = 1;     // start
      if (touche == '6') grafcet_cw = 9999;    // stop
      if (touche == '7') CW_PITCH /= demiton;
      if (touche == '8') CW_PITCH *= demiton;
      if (touche == '9') { CW_SPEED = 12; CW_PITCH = 700; grafcet_cw = 1; }    // reset
      grafcet_a--;
      if (touche == '0') { strcpy(cw_texte,"OK\0" );  grafcet_a=9999; }    // menu
// vitesse CW
      CW_DOTLEN=1200/CW_SPEED;
      CW_DASHLEN=3.5*CW_DOTLEN;
      if (touche != '1' && touche != '2') strcpy(cw_texte,"K");
      touche = ' ';
    }
    if (tempo_a == 0) grafcet_a--;
  break;
//--------------------------------
// si grafcet_a n'a pas une valeur correcte, on passe ici
  default: 
  case 9999:
      lcd.clear();
      grafcet_a = 10; // on retourne au menu général
  break;
}
//--------------------------------********************--------------------------------
// GRAFCET MORSE CW
/* Fontionnement :
Placer dans 'cw_texte' la chaine de carctères à émettre :
    strcpy (cw_texte,"Bonjour");        / manipulera BONJOUR (uniquement majuscules en MORSE !)
    strncpy (cw_texte,"Bonjour",3);    // manipulera BON
On peut aussi charge 'cw_texte_att' qui ne sera manipulé qu'après 'tempo_attcwval' millisecondes, 
      si il n'a pas changé ! 
*/
switch (grafcet_cw) {

// attente caractères
  case 1:
  if ( tempo_cw == 0 ) {              // si la tempo est terminée,
// on arme la tempo de surveillance a la vitesse des points, ce qui est suffisant
    tempo_cw = CW_DOTLEN;
// texte temporisé : on MORSE si pas changé depuis tempo_attcw
    if (strlen(cw_texte_att) > 0) {
      if (strcmp(cw_texte_old,cw_texte_att) != 0) {
        strcpy(cw_texte_old,cw_texte_att);
        tempo_attcw = 2000;    // durée de stabilité avant manipulation
      }
// le texte temporisé n'a pas changé, la tempo est-elel finie ?
      if ( tempo_attcw == 0) {
        strcpy(cw_texte,cw_texte_att);
//        cw_texte_att[0] = '\0';
      }
    }
      
// texte immédiat : on MORSE tout de suite
    if (strlen(cw_texte) > 0) {
      cw_texte_att[0]='\0';
      cw_pos=0;
      grafcet_cw = 2;               // et on passe à l'étape suivante
    }
  }
  break;

  case 2:
  if ( tempo_cw == 0 ) {
// fin de texte
    if (cw_pos >= strlen(cw_texte) or cw_texte[cw_pos] == '\0') {
      cw_texte[0]='\0';
      grafcet_cw=1;
      lcd.setCursor(15, 1); lcd << '_';
      break;
    }
    cw = cw_texte[cw_pos];
    if (cw >= 'a' and cw <= 'z') cw = cw & 0XDF; // en MAJUSCULES
    cw_pos++;
    lcd.setCursor(15, 1); lcd << cw ;
 
// caractère suivant
    if (cw == ' ') {
      tempo_cw = 7*CW_DOTLEN;
      grafcet_cw=2;
      break;
    }
    if (cw == '$') {
      grafcet_cw=20;
      break;
    }
// recherche du pattern du caractère suivant
    for (i=0; i<CW_N_MORSE; i++) {
      if (morsetab[i].c == cw) {
        pw = morsetab[i].pat;
        grafcet_cw++;
      }        
    }
  }    
  break;

// TONE du bit suivant
  case 3:
   if (tempo_cw == 0) {
    if (pw != 1) {
// TIT ou TAAH
      if (pw & 1) tempo_cw = CW_DASHLEN; else tempo_cw = CW_DOTLEN;
//      tone(sortie_gbf, CW_PITCH) ;
      pw = pw / 2 ;
      grafcet_cw++;    // TIT ou TAAH ?
// silence inter-caractères
    } else {
      tempo_cw = 2*CW_DOTLEN;  
      grafcet_cw=2; 
    }
   }
  break;

// silence 1 TIT
  case 4:
    if (tempo_cw == 0) { tempo_cw = CW_DOTLEN;  grafcet_cw=3; }
//    if (tempo_cw == 0) { noTone(sortie_gbf);  tempo_cw = CW_DOTLEN;  grafcet_cw=3; }
  break;

// BIP 1750 par envoi de "$" ou "$freq" ou  "$freq,duree"
  case 20:
    if (tempo_cw == 0) { tempo_cw = CW_DASHLEN;  grafcet_cw++;  }
//    if (tempo_cw == 0) { tone(sortie_gbf, 1750);  tempo_cw = CW_DASHLEN;  grafcet_cw++;  }
  break;
// fin du BIP
  case 21:
//    if (tempo_cw == 0) { noTone(sortie_gbf); grafcet_cw=2; }
  break;

// FIN, arrêt CW
// si grafcet_cw n'a pas une valeur correcte, on passe ici
  default: 
  case 9999:
//    noTone(sortie_gbf); 
    grafcet_cw=0;  
  break;
}      // fin du "switch"
 
// FIN GRAFCET MORSE CW
//--------------------------------********************--------------------------------
// FREQUENCEMETRE INDEPENDANT
switch (grafcet_frequencemetre) {
// attente
  case 1:
  break;

// init
 case 2:
  FreqCounter::start(gatetime);  // Gate Time durée du comptage, 1er lancement
  grafcet_frequencemetre++;
  break;

// attente fin comptage non bloquant
 case 3:
  if (FreqCounter::f_ready == 1) {
    freq = (float) FreqCounter::f_freq*1000./gatetime;		// lecture fréquence

// ajustement de la durée d'échantillonage en fonction de la fréquence
// - on a besoin de 6 à 7 chiffres maxi (précision des float)
// - la fréquence maxi admissible est 8.000.000 Hz
// - on affiche finalement que 4 chiffres pour les C et L
    gatetime=100;
    if (freq < 1000000) gatetime=1000;
//    if (freq < 10000) gatetime=100;
//    if (freq < 1000) gatetime=1000;
//    FreqCounter::start(gatetime);  // Gate Time durée du comptage : multiple de 2, maxi 1000
    grafcet_frequencemetre=1;
  }
  break;

// si grafcet_a n'a pas une valeur correcte, on passe ici
  case 9999: 
  default: 
    grafcet_frequencemetre = 0; // on arrête
  break;
}      // fin du "switch"
//--------------------------------********************--------------------------------
// GRAFCET B (modèle)
switch (grafcet_b) {

  case 1:
  if ( tempo_b == 0 ) {        // si la tempo est terminée,
    horodatage_serial(); Serial << " grafcet_b=" << grafcet_b <<  " grafcet_a=" << grafcet_a <<endl;
    tempo_b = tempo_b_reset;             // on arme la tempo
    grafcet_b++;               // et on passe à l'étape suivante
  }
  break;      // cette instruction vous fait sauter à la fin du "switch"

  case 2:
  if ( tempo_b == 0 ) {
    horodatage_serial(); Serial << " grafcet_b=" << grafcet_b <<  " grafcet_a=" << grafcet_a << endl;
    tempo_b = tempo_b_reset;             // on arme la tempo
    grafcet_b=1;               // on reboucle
  }    
  break;

// si grafcet_a n'a pas une valeur correcte, on passe ici
  default: 
      grafcet_b = 0; // on arrête
  break;
}      // fin du "switch"
// FIN GRAFCET B
//--------------------------------********************--------------------------------
}
// ************************************************************************************************
// ************************************************************************************************
// SOUS-PROGRAMMES
// ************************************************************************************************
/* scrutation et filtrage de clavier analogique

  utilisation "monocoup" :
  if (touche == '1') { ...; touche=' ';}

  utilisation avec "répétition" :
  if (touche_repeat == '1') { ...; touche_repeat=' ';}
*/
void ger_scrute_clavier(){
// clavier - filtrage
  itouche4 = itouche3;
  itouche3 = itouche2;
  itouche2 = itouche1;
  itouche1 = itouche;
  itouche = analogRead(clavier);
// pour calibrage
//  if (itouche < 1020 ) Serial.println(analogRead(clavier));

// si la touche est stable (X tours)
//  if ((itouche)==itouche2 && itouche1==itouche2) {
  if (itouche==itouche1 && itouche==itouche2 && itouche==itouche3 && itouche==itouche4) {

// Donc en appliquant la formule n = ( valeur_ana + 20 ) / 41 on devrait récupérer le No de la touche de 0 à 9 ...

// recherche quelle touche
    ntouche=-1;
    do {
      ntouche++;
    } while (itouche > ((xtouche[ntouche]+xtouche[ntouche+1])/2) && ntouche < nbtouche);
// debug lcd.setCursor(0, 1);  lcd << "t=" << ltouche[i] << "," << itouche << "    ";    // 2eme ligne lcd
// si la touche a varié
    if (ltouche[ntouche] != vtouche ) {
      vtouche = ltouche[ntouche];
// touche valide
      if (ntouche < nbtouche) { 
        touche = vtouche;
        touche_repeat = vtouche;
        tempo_repeat=800;  // duree avant repetition
// arret répétition
      } else {
        touche_repeat = ' ';
      }
// si la touche est la même : repeat ?
    } else {
      if (ntouche < nbtouche && tempo_repeat == 0 ) {
        touche_repeat = vtouche;
        tempo_repeat=400;  // vitesse repetition
      }
    }
  }
  return;
}
// ************************************************************************************************
// Programme au -ieme de seconde
// gestion des temporisations
// NB : le débordement du compteur en (unsigned long) a lieu tous les 50 jours environ ...
void ger_top_centieme (){
  unsigned long delta;
  unsigned long currentMillis = millis();

// Centième de secondes
  delta = currentMillis - previousMillis;
  if (delta >= 10) {
// save the last time you come here
    previousMillis = currentMillis;   

// scrutation du clavier toutes les 10ms
    ger_scrute_clavier();

// allumage temporisé led clavier
//    if (lamp_tempo >= delta) { lamp_tempo -= delta; digitalWrite(lamp, HIGH); } else { lamp_tempo = 0; digitalWrite(lamp, LOW); }

// gestion des TEMPORISATIONS (en ms mais précise à 10ms près)
    if (tempo_a >= delta ) { tempo_a -= delta; } else { tempo_a = 0; }
    if (tempo_b >= delta ) { tempo_b -= delta; } else { tempo_b = 0; }
    if (tempo_repeat >= delta ) { tempo_repeat -= delta; } else { tempo_repeat = 0; }
    if (tempo_cw >= delta ) { tempo_cw -= delta; } else { tempo_cw = 0; }
    if (tempo_attcw >= delta ) { tempo_attcw -= delta; } else { tempo_attcw = 0; }
//    if (fonction_tempo >= delta) { fonction_tempo -= delta; } else { fonction_tempo = 0; }
  }

// Dixième de seconde
   delta = currentMillis - previousDecis;
   if (delta >= 100) {
    previousDecis = currentMillis;   
    top_dixieme = true;
    
// tops seconde et minute pour traitements dans le main
    if (second() != previousSecond) {
      previousSecond = second();
      top_seconde = true;
      if (previousSecond == 0) top_minute=true;
    }
  }
  return;
}
// ************************************************************************************************
// affichage horloge complete sur la sortie serie, sans fin de ligne
void horodatage_serial() {
// digital clock display of the time
//  Serial << day() << "/" << month() << "/" << year() << " " << hour() << printDigits(minute()) << printDigits(second()) << endl; 
  Serial << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year() << " " << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second();
}
// ************************************************************************************************

/*
Convertit  la valeur 'float' "v" avec "nbchiffres" digits significatifs suivi de l'"unite"
Donc "nbchiffres" digits + point + multiplicateur + unite = "nbchiffres+3" caractères
Résultat dans 'buf'.
Usage :
char valuef[15];
    freq=123456.789;
    formatf(freq,'c',5,valuef);                     // valuef="123.45Kc\0"
    freq=1.23456789;
    formatf(freq,'c',8,valuef);                     // valuef="1.2345678c \0"
    Serial << "F=" << valuef;                       // sur voie série
    lcd.setCursor(0, 0);  lcd << "F=" << valuef;    // sur LCD
    strcpy(cw_texte,valuef);                        // en MORSE
*/
void formatf(float v,char unite,int nbchiffres,char buf[15])
{
//      dtostrf(floatVar, minStringWidthIncDecimalPoint, numVarsAfterDecimal, charBuf);

 float vloc;
 int mult=5,nbdec;
//   mult =            0    1    2    3    4    5   6     7     8    9
//   multiplicateur =  Peta Tera Giga Mega Kilo *   milli micro nano pico
 char multiple[10] = {'P', 'T', 'G', 'M', 'k', ' ','m',  'u',  'n', 'p'};
  vloc=v;
// si valeur inférieure à 1, on multiplie
  while (vloc < 1. && mult < 9) {
     vloc = vloc*1000;
     mult++;
   }
// si valeur grande, on divise
   while (vloc >= 1000. && mult > 0) {
     vloc = vloc/1000;
     mult--;
   }
// nombre de décimales selon valeur   // ex nbchiifres=4    7
   nbdec = nbchiffres-3;              //           999.9  999.9999
   if (vloc < 100 ) nbdec++;          //           99.99  99.99999
   if (vloc < 10 ) nbdec++;          //           9.999  9.999999
// convesrion FLOAT CHAR
   dtostrf(vloc,nbchiffres,nbdec,buf);
// ici, nbdec devient la longueur obtenue (rien à voir avec le nombre de décimales)
   nbdec=strlen(buf);
   if (mult!=5) {
     buf[nbdec+1]=unite; buf[nbdec]=multiple[mult];
   } else {
     buf[nbdec]=unite; buf[nbdec+1]=multiple[mult];
   }
// fin de CHAR
   buf[nbdec+2]='\0';
//   Serial << "*buf=" << buf << "*l=" << strlen(buf) << "*" << endl;
   return;
}
// ************************************************************************************************
// ************************************************************************************************
// ARCHIVES, NOTES ...
// ************************************************************************************************
/*
// AUTRES CONVERSIONS
char* dtostrf  ( double  __val,  
  signed char  __width,  
  unsigned char  __prec,  
  char *  __s  
 ) 
 
 char* itoa  ( int  __val,  
  char *  __s,  
  int  __radix  
 ) 

char* ltoa  ( long int  __val,  
  char *  __s,  
  int  __radix  
 ) 

dtostrf(vloc,nbchiffres,nbdec,cw_texte);
   nbdec=strlen(cw_texte);
   cw_texte[nbdec]=multiple[mult];
   cw_texte[nbdec+1]=unite;
   cw_texte[nbdec+2]='\0';
   }
*/
/*
// Transforme la date et l'heure "lisible" en format UNIX pour mise à l'heure et date
time_t setupArduinoTime(int y,int m, int j, int h, int mi, int se) {
  tmElements_t tm;
  tm.Year = y-1970;
  tm.Month = m;
  tm.Day = j;
  tm.Hour = h;
  tm.Minute = mi;
  tm.Second = se;
  time_t time = makeTime(tm);
  return time;
}
//+ voici le s/p original qui provient d'une bibliothèque pour GPS :
time_t gpsTimeToArduinoTime(){
// returns time_t from gps date and time with the given offset hours
  tmElements_t tm;
  int year;
  gps.crack_datetime(&year, &tm.Month, &tm.Day, &tm.Hour, &tm.Minute, &tm.Second, NULL, NULL);
  time_t time = makeTime(tm);
  return time + (offset * SECS_PER_HOUR);
}
*/
// ************************************************************************************************
// ************************************************************************************************

