#define version "F1FWG.13"
/*
  Fréquencemètre réel : problème de compatibilité de <FreqCounter.h> avec <Time.h> !!! ???
  frequency mis en //
  
// *** nnn *** fonctionnalités repérées par ce titre. 
On retrouve ces repères dans les inclusions de bibliothèques, les déclarations, les initialisations (void setup())

  Voltmètre U1 U2 U3
  Morse
  GBF
  Fréquencemètre, capacimètre, selfmètre : simulés
  ---
  Modes et menu général
  Clavier analogique à diodes et debug
  LCD
  Gestion du temps
  Compactage des sorties série (intégration d'une bibliothèque : Streaming)
  GRAFCET
  TEMPORISATION basique
  FRONT MONTANT/DESCENDANT
*/
//**********************************************************
// BIBLIOTHEQUES
// incluses dans le package Arduino de base
// *** LCD *** afficheur LCD
#include <LiquidCrystal.h>  // LCD

// ajoutées
// *** GENERAL *** formatage des entrees sorties ASCII
#include <Streaming.h>
// *** TEMPS ***
#include <Time.h>

// *** CAPAcimetre SELFmetre FREQuencemetre *** 
/*
  Martin Nawrath KHM LAB3
  Kunsthochschule f¸r Medien Kˆln
  Academy of Media Arts
  http://www.khm.de
  http://interface.khm.de/index.php/labor/experimente/	
  http://interface.khm.de/index.php/lab/experiments/arduino-frequency-counter-library/
  NB : l'entrée de comptage est le D5
*/
//#include <FreqCounter.h>

//**********************************************************
// DECLARATIONS
// *** GENERAL *** DEBUG : 0=pas de debug, valeur selon besoins
#define debug 1

// *** LCD *** afficheur cristaux liquides, led heart-beat
// initialize the library with the numbers of the interface pins
/* Câblage du LCD
 * LCD pin 1 to GND
 * LCD pin 2 to VCC 5V
 * LCD pin 3 : contraste sur le point milieu d'un potentiomètre de 10K entre le GND et le VCC (réglé très près de la masse)
 * LCD pin 4 RS to digital pin 4
 * LCD pin 5 RW to GND
 * LCD pin 6 Enable pin to digital pin 2
 * LCD pin 11 D4 pin to digital pin 6
 * LCD pin 12 D5 pin to digital pin 7
 * LCD pin 13 D6 pin to digital pin 8
 * LCD pin 14 D7 pin to digital pin 9
*/
//  LiquidCrystal lcd(RS, Enable,  D4, D5, D6, D7)
  LiquidCrystal lcd(4, 2, 6, 7, 8, 9);

// entrées-sorties
// *** LCD *** afficheur cristaux liquides, led heart-beat
#define led_a 13
// *** GBF *** générateur basse fréquence, pwm, servo
#define sortie_gbf 3

// temporisations
int tempo_a,tempo_b;
// vitesse de clignotement : maintenant en millisecondes
int tempo_a_reset=1000;
int tempo_b_reset=700;
// *** TEMPS *** gestion du temps
int previousSecond;      // secondes de l'horloge
int top_dixieme=false;   // top pour traitements au 1/10 seconde dans le P/P
int top_seconde=false;   // top pour traitements à la seconde dans le P/P
int top_minute=false;   // top pour traitements à la minute dans le P/P
unsigned long previousMillis, previousDecis;
char* jours[] = {"Sam","Dim","Lun","Mar","Mer","Jeu","Ven"} ;

#include "decl0000_clavier.h"

// *** CAPAcimetre SELFmetre FREQuencemetre *** 
float self,self0,capa,capa0,freq,freq0;
// fréquencemetre
int gatetime=100;
int grafcet_frequencemetre=0;

// *** VOLTmetre ***
#define entree_U1 A1
#define entree_U2 A2
#define entree_U3 A3
float U1,U2,U3;

#include "decl1300_morse.h"

// *** GENERAL *** 
// speedomètre = calcul de vitesse ...
unsigned int tours_ps,tours,tours_led;
// GRAFCETS
int grafcet_a=10;
int grafcet_b=0;

// definition des modes de fonctionnement correspondant aux différentes fonctions possibles
#define modemax 13
int mode=0,modeav=modemax,modeap=1;
static char* modex[]={"Horl","Freq", "Lslf", "Capa", "Volt", "GBF_","PWM_","Srvo","Acco","Baro","Ther","Reve","Kafe","Mors"};
//                      0      1      2        3       4       5      6      7      8      9       10    11     12     13     14     15    16
// si valid=-1 = option non valide, sinon valeur de démarrage de grafcet_a
static int  valid[]={  0   ,   100,    200,    300,    400,    500,   -600,   -700,   -800,   -900,  -1000,  -1100,  1200,  1300,  -1400,  -1500 };
//static int*  valid[]={  0   ,   100,    200,    300,    400,    500,   600,   700,   800,   900,  1000,  1100,  1200,  1300,  1400,  1500 };

static char* menus[]={" --  ++  Ok  Ok ","-vit+ O 1 Pitch"," --  -    +  ++ "};
//             0=général          1=morse          2=GBF
//--------------------------------
/* MODES : on arme le grafcet à mode*100
mode - fonction
 0 - horloge basique
 1 - fréquencemètre (8 Mhz à priori, c'est facile le selfmètre capacimètre en est un)
 2 - un selfmètre capacimètre (c'est l'idée de départ) ???
 3 - capacimètre
 4 - un multi-voltmètre 20 Volts, ampèremètre éventuel (détecteur à faire, mais je connais l'astuce) ???
 5 - un GBF (ce que peut faire l'Arduino, sans doute jusque vers 30 kHz)
 6 - mais aussi générateur de signal pour tester des servo moteurs de télécommande ???
 7 - et encore générateur de commande PWM ???
 8 - un accordeur de guitare ou autre bombarde (quand j'aurais connecté un HP) ???
 9 - un baro-thermomètre à base de BMP085 (bus I2C sur A4+A5) ???
 10 - un appareil de mesure de capacité isolante d'un mur (avec 3 capteurs DS1820 bus 1 fil sur A5) ???
 11 - horloge réveil temporisation ( synchro avec horloge temps réel DS1307 ou horloge radio DFM77 ??? )
 12 - pas le café, quoi que ... 
 13 - la gestion du Morse (indicateur sonore)
 - une alimentation 5V et 12 V pour bidouiller 
*/
//--------------------------------
// variables très locales !
int i,j;
char valuef[15],valueff[15],valuefff[15];    // pour sorties du S/P formatf

// Constantes sympas avec une précision suffisante (Arduino gère 7 à 8 decimales)
#define deuxpi  6.283185307 //179586476925286766559;  // à peu près 2 Pi
#define racine2 1.414213562 //3730950488016887242097; // racine carree de 2
#define demiton 1.059463094 //3592952645618252949463; // 2 puissance 1/12 rapport de fréquence entre 2 notes séparées d'un demi-ton

//**********************************************************
// SOUS-PROGRAMMES
// gestion du temps, formatages, gestion clavier
#include "sp.h"

//**********************************************************
// INITIALISATIONS
void setup() {
// initialize the pins
  pinMode(led_a, OUTPUT);
  pinMode(sortie_gbf, OUTPUT);
  pinMode(clavier, INPUT);
  digitalWrite(clavier,HIGH);    // résistance de pullup

  pinMode(entree_U1, INPUT);
  pinMode(entree_U2, INPUT);
  pinMode(entree_U3, INPUT);

// définition taille du LCD :
  lcd.begin(16, 2);

// mise à l'heure
  setTime(00,00,00,25,12,13); // 00h00 le 25 déc 2013 setupArduinoTime(2013,25,21,12,15,00));

// ligne série (pour traces)
  Serial.begin(9600);  // ou 9600 selon votre port COM
#if debug > 0  
  Serial << "Serial ok" << endl;
#endif

// fréquencemetre
//  FreqCounter::f_comp=0;   // Cal Value / Calibrate with professional Freq Counter

//  
// BIP de Start     123456789012345678901234567890
  strncpy(cw_texte,"cdefga4b4c4b4a4gfedcegc4e4g4c5\0",30);  // Bip
  
} // Fin du SETUP
//**********************************************************
// PROGRAMME PRINCIPAL
void loop() {

// mise à l'heure par message "T12,34,56,01,01,13"
  if(Serial.available() ) { misealheure(); }

// compte-tours par seconde et led_a "heart-beat" commutée
  if (tours < 65535) tours++;
  tours_led++;
  if (tours_led > 10000) { tours_led = 0 ;  digitalWrite(led_a, !digitalRead(led_a)); } 
  
// gestion du temps (dont temporisations)
  ger_top_centieme ();
  
// opérations à chaque dixième de seconde
  if (top_dixieme) {
    top_dixieme = false;
  }
 
// opérations à chaque seconde
  if (top_seconde) {
    top_seconde = false;
    tours_ps=tours; tours=0;
  }

// vitesse CW
  CW_DOTLEN=1200/CW_SPEED;
  CW_DASHLEN=3.5*CW_DOTLEN;

//--------------------------------********************--------------------------------
switch (grafcet_a) {

//--------------------------------
// mode horloge basique
  case 0:
      strncpy(cw_texte,"$\0",2);  // Bip
      lcd.clear(); lcd.setCursor(0, 1); lcd << "Menu " << version;
      grafcet_a++;
  break;
  
  case 1:
// appel menu général
    if (touche != ' ') {
      grafcet_a = 10;
      touche = ' '; 
    }
// horloge de base
    if (tempo_a == 0) {
      tempo_a = 1000;
      horodatage_serial(); Serial << " top" << tours_ps << "t/s    " << grafcet_a << " " << grafcet_b << endl;
      lcd.setCursor(0, 0);
      if (second()%10 > 7) {
//         lcd << dayStr(weekday()) << " " << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year();
         lcd << " " << jours[weekday()] << " " << ((day()<10)?"0":"") << day() << "/" << ((month()<10)?"0":"") << month() << "/" << year() << " " ;
      } else {
//         lcd << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << "  " << ((tours_ps<1000)?" ":"")  << tours_ps;
         lcd << "  " << ((hour()<10)?"0":"") << hour() << ":" << ((minute()<10)?"0":"") << minute() << ":" << ((second()<10)?"0":"") << second() << "   GER";
      }
    }
  break;

//--------------------------------
// mode par défaut, attente de choix d'un mode
  case 10:
//  affichage menu déroulant horizontal
    modeav=mode;
    do {
      modeav = ((modeav>0)?modeav-1:modemax);
    } while (valid[modeav] < 0);
    modeap=mode;
    do {
       modeap = ((modeap<modemax)?modeap+1:0);
    } while (valid[modeap] < 0);
// ou plus simplement (mais 4 octets de plus !!!) :   if (mode < modemax ) { modeap = mode+1; } else { modeap = 0; }
    lcd.setCursor(0, 0);  lcd << modex[modeav] << " <" << modex[mode] << "> " << modex[modeap] ; 
    lcd.setCursor(0, 1);  lcd << menus[0]; 
    grafcet_a++;
    tempo_a = 15000; // on arme la tempo, si on n'a pas choisi avant la fin, on passe en horloge
    strncpy ( cw_texte_att, modex[mode], 1 ); // on récupère que le 1er caractère
  break;

  case 11:  
// envoi en CW de l'option affichée
// retour à l'horloge
    if (tempo_a == 0) { grafcet_a = 0; }
// - sans répétition
    if (touche == '3') {
      mode = modeav; 
      grafcet_a = 10;
      touche = ' ';
      strncpy ( cw_texte,"c", 1 ); // bop
// annonce option en Morse
      strncpy ( cw_texte_att,modex[mode], 1 ); 
    }
// + avec répétition
    if (touche_repeat == '4') {
      mode = modeap; 
      grafcet_a = 10;
      touche_repeat = ' ';
      strncpy ( cw_texte,"g", 1 );  // bip
// annonce option en Morse
      strncpy ( cw_texte_att,modex[mode], 1 ); 
    }
// Ok
    if (touche != ' ' and touche != '4') {    // 3 est exclue du fait que traitée avant !
      strncpy ( cw_texte,modex[mode], 1 ); 
      grafcet_a = valid[mode]; // 100*mode;
      tempo_a = 0;
      Serial << modex[mode] << endl;
      lcd.clear(); touche_repeat = ' '; touche = ' ';
    }
  break;

//--------------------------------
// Frequencemetre
  case 100:
    if (touche == '9') {
//      formatf(freq,'c',7,valueff);
      strcpy(cw_texte,valueff);
      lcd.setCursor(0, 1);  lcd << valueff;
      touche = ' ';
    }
    if (touche == '0') {
      grafcet_frequencemetre = 9999; // Arrêt du fréquencemètre
      touche = ' ';
      grafcet_a=9999;    // pour raz grafcet
    }
    if (tempo_a == 0) { tempo_a=100; grafcet_a++;}
  break;

  case 101:
    if (grafcet_frequencemetre < 2) {
      lcd.setCursor(11, 1);  lcd << "St";  // conversion démarre
      grafcet_frequencemetre = 2; // démarrage du fréquencemètre
      grafcet_a++;               // et on passe à l'étape suivante
//    freq = 144612500.;        // simulation
      tempo_a = 100+gatetime;
    }
    if (tempo_a == 0 || touche != ' ') { grafcet_a=100;}
  break;

  case 102:
    if (grafcet_frequencemetre == 1) {      // conversion terminée
      lcd.setCursor(11, 1);  lcd << "Ok";  // conversion OK
//    freq += 0.001*millis();
      formatf(freq,'c',7,valueff);
      lcd.setCursor(0, 0);  lcd << modex[mode] << "=" << valueff;
      Serial << modex[mode] << "=" << valueff  << endl;
      tempo_a = 100;             // on arme la tempo
      grafcet_a=100;
    }
    if (tempo_a == 0 || touche != ' ') { grafcet_a=100;}
  break;

    
//--------------------------------
// Selfmetre - Capacimètre
/*
FORMULES de BASE des circuits oscillants
  1(un)=LCw²
  F=2*Pi*w
  1=L*C*(2Pi*F)²
  L=1/(C*(2Pi*F)²)
  C=1/(L*(2Pi*F)²)
  F=Racine(1/L*C)/2*Pi

Voir aussi Wikipedia : http://fr.wikipedia.org/wiki/Circuit_LC
*/
  case 200:
  case 300:
    self=0.000068;          // 68 uH
    capa=0.000000000680;    // 680 pF
    grafcet_a++;               // et on passe à l'étape suivante
//    if (grafcet_frequencemetre ==0) grafcet_frequencemetre = 1; // démarrage du fréquencemètre
//    self = self0; capa = capa0; // pour simulation
  break;

  case 201:
  case 301:
    lcd.setCursor(0, 0);  lcd << modex[mode] << "=" ; 
    Serial << modex[mode] << " " ; 
// Capacimètre
    if (grafcet_a > 250) { 
//      x = 1. / (self * pow(deuxpi * freq, 2.));    // C = 1 / (L * (2 * Pi * F)²) 
//    capa = x-capa0;
      capa *= 1.41421356;
      formatf(capa,'F',4,valueff);
      formatf(self,'H',4,valuef);
      lcd << valueff;
      lcd.setCursor(0, 1); lcd << valuef;
      Serial << " " << valueff << " " << valuef; 

// Selfmetre
    } else { 
//      x = 1. / (capa * pow(deuxpi * freq, 2.));    // L = 1 / (C * (2 * Pi * F)²) 
//      self = x-self0;
        self *= 1.41421356;
      formatf(self,'H',4,valueff);
      formatf(capa,'F',4,valuef);
      lcd << valueff;
      lcd.setCursor(0, 1); lcd << valuef;
      Serial << " " << valueff << " " << valuef; 
    }
 // calcule la fréquence de résonnance   
    freq = 1. / (deuxpi * pow(self*capa,0.5));    // F = 1 / (2 * Pi * racine_carree ( L * C ))
    formatf(freq,'c',4,valuef);
    Serial << " " << valuef << endl;
    lcd << " " << valuef;
    tempo_a = 2500;             // on arme la tempo
    grafcet_a++;               // et on passe à l'étape suivante
    if (capa > 0.000000680 or self > 0.068 ) grafcet_a-=2;
  break;

  case 202:
  case 302:
    if (touche == '0') {
      touche = ' ';
//    grafcet_frequencemetre = 9999; // Arrêt du fréquencemètre
      grafcet_a=9999;    // pour raz grafcet
    }
    if (touche == '1') {
      self=0.01-self;
      capa=0.0000001-capa;
      grafcet_a--;
      touche = ' ';
    }
// morse à la demande
    if (touche == '9') {
//      formatf(freq,'c',7,valueff);
      strcpy(cw_texte,valueff);
      touche = ' ';
    }
    if (tempo_a == 0) grafcet_a--;
  break;

//--------------------------------
// VOLTmetre
  case 400:
    if (tempo_a == 0) {
      tempo_a = 333;
      U1 = 0.02 * analogRead(entree_U1);
      U2 = 0.02 * analogRead(entree_U2);
      U3 = 0.02 * analogRead(entree_U3);
      formatf(U1,'V',4,valuef);
      formatf(U2,'V',4,valueff);
      formatf(U3,'V',4,valuefff);

      lcd.setCursor(0, 0);  lcd << modex[mode] << "    " << valuef;
      lcd.setCursor(0, 1); lcd << valueff << " " << valuefff;

      horodatage_serial(); Serial << " " << modex[mode] << " U1=" << valuef; 
      Serial << " U2=" <<  valueff << " U3=" << valuefff << endl;
    }
// U3
    if (touche == '9') {
      strcpy(cw_texte,valuef);
      touche = ' ';
      grafcet_a++;
    }
// U2
    if (touche == '8') {
      strcpy(cw_texte,valueff);
      touche = ' ';
      grafcet_a++;
    }
// U1
    if (touche == '7') {
      strcpy(cw_texte,valuefff);
      touche = ' ';
      grafcet_a++;
    }
// sortie VOLTmetre
    if (touche != ' ') {
      touche = ' ';
      grafcet_a=9999;    // pour raz grafcet
    }
    break;
    
    case 401:
      if (grafcet_cw == 1) {
         tempo_a = 666;
         grafcet_a = 400;
      }
      break;
  
//--------------------------------
// GBF
  case 500:
    freq=440.; // Hertz
//  pwm = 127;
//  servo = 90;
    grafcet_a++;               // et on passe à l'étape suivante
  break;

  case 501:
    if (freq < 20.) freq=20.;
    if (freq > 20000.) freq=20000.;
    formatf(freq,'c',5,valuef);
    Serial << modex[mode] << " F=" << valuef; 
    lcd.setCursor(0, 0);  lcd << modex[mode] << " F=" << valuef;
    lcd.setCursor(0, 1);  lcd << menus[2]; 

// GBF
   tone(sortie_gbf, (unsigned int) freq); // ms
// PWM
//    analogWrite(0-255) 
// Servo
//  myservo.attach(sortie_GBF);
//  myservo.write(90);  // 0-180 set servo to mid-point

    tempo_a = 200;
    grafcet_a++;               // et on passe à l'étape suivante
  break;
  
  case 502:
    if (touche == '0') {
      noTone(sortie_gbf); 
      touche = ' ';
      grafcet_a=9999;    // pour raz grafcet
    }
    if (touche == '1') freq = 440.;
    if (touche == '2') freq = 880.;
    if (touche == '3') freq /= racine2;
    if (touche_repeat == '4') { freq /= demiton; touche_repeat = ' '; }
    if (touche_repeat == '5') { freq *= demiton; touche_repeat = ' '; }
    if (touche == '6') freq *= racine2;
    if (touche == '7') freq = 1760.;
    if (touche == '8') freq = 3520.;
    if (touche == '9') freq = 7040.;
    if (touche != ' ') { grafcet_a--;  touche = ' '; }
    if (tempo_a == 0) grafcet_a--;
  break;

//--------------------------------
// Café (en fait, bidouille)

  case 1200:
    i=0;
    grafcet_b=1;
    grafcet_a++;
  break;

  case 1201:
// chenillard
    lcd.setCursor(i, 0);  lcd << " "; 
    i++; if (i>15) i=0;
    lcd.setCursor(i, 0);  lcd << "*"; 
// 2 grafcets
    lcd.setCursor(0, 1); lcd << grafcet_a << "ab" << grafcet_b << "    ";
    lcd.setCursor(11, 1); lcd << tours_ps << "   ";
    tempo_a = 500;             // on arme la tempo
    grafcet_a++;
  break;

  case 1202:
    if (touche == '0') {
      touche = ' ';
      grafcet_b=0;
      grafcet_a=9999;    // pour raz grafcet
    }
    if (tempo_a == 0) grafcet_a=1201;
  break;   


//--------------------------------
#include "gest1300_morse.h"
//--------------------------------
// si grafcet_a n'a pas une valeur correcte, on passe ici
  default: 
  case 9999:
      lcd.clear();
      grafcet_a = 10; // on retourne au menu général
  break;
}
//--------------------------------********************--------------------------------
#include "graf1300_morse.h"
//--------------------------------********************--------------------------------
// GRAFCET B (modèle)
switch (grafcet_b) {

  case 1:
  if ( tempo_b == 0 ) {        // si la tempo est terminée,
    horodatage_serial(); Serial << " grafcet_b=" << grafcet_b <<  " grafcet_a=" << grafcet_a <<endl;
    tempo_b = tempo_b_reset;             // on arme la tempo
    grafcet_b++;               // et on passe à l'étape suivante
  }
  break;      // cette instruction vous fait sauter à la fin du "switch"

  case 2:
  if ( tempo_b == 0 ) {
    horodatage_serial(); Serial << " grafcet_b=" << grafcet_b <<  " grafcet_a=" << grafcet_a << endl;
    tempo_b = tempo_b_reset;             // on arme la tempo
    grafcet_b=1;               // on reboucle
  }    
  break;

// si grafcet_a n'a pas une valeur correcte, on passe ici
  default: 
      grafcet_b = 0; // on arrête
  break;
}      // fin du "switch"
// FIN GRAFCET B
//--------------------------------********************--------------------------------
}
//--------------------------------********************--------------------------------
//--------------------------------********************--------------------------------

