//--------------------------------********************--------------------------------
// GRAFCET MORSE CW
/* Fonctionnement :
Placer dans 'cw_texte' la chaine de carctères à émettre :
    strcpy (cw_texte,"Bonjour");        / manipulera BONJOUR (uniquement majuscules en MORSE !)
    strncpy (cw_texte,"Bonjour",3);    // manipulera BON
On peut aussi charge 'cw_texte_att' qui ne sera manipulé qu'après 'tempo_attcwval' millisecondes, 
      si il n'a pas changé ! 
*/
switch (grafcet_cw) {

// attente caractères
  case 1:
// texte immédiat : on MORSE tout de suite
    if (strlen(cw_texte) > 0) {
      cw_texte_att[0]='\0';
      strcpy(cw_texte_old,cw_texte_att);
      cw_pos=0;
      cwcw = 0; // c'est de la musique a priori !
      grafcet_cw = 2;               // et on passe à l'étape suivante
    }

  if ( tempo_cw == 0 ) {              // si la tempo est terminée,
// on arme la tempo de surveillance a la vitesse des points, ce qui est suffisant
    tempo_cw = CW_DOTLEN;
// texte temporisé : on MORSE si pas changé depuis tempo_attcw
    if (strlen(cw_texte_att) > 0) {
      if (strcmp(cw_texte_old,cw_texte_att) != 0) {
        strcpy(cw_texte_old,cw_texte_att);
        tempo_attcw = 2000;    // durée de stabilité avant manipulation
      }
// le texte temporisé n'a pas changé, la tempo est-elle finie ?
      if ( tempo_attcw == 0 && cw_texte_att[0] != '\0') {
        strcpy(cw_texte,cw_texte_att);
        memset (cw_texte_att,'\0',15);
//        cw_texte_att[0] = '\0';
      }
    }
  }
  break;

// passage au caractère suivant
  case 2:
  if ( tempo_cw == 0 ) {
// fin de texte
    if (cw_pos >= strlen(cw_texte) or cw_texte[cw_pos] == '\0') {
      memset (cw_texte,'\0',30); //cw_texte[0]='\0';  // RAZ ???
      grafcet_cw=1;
      lcd.setCursor(15, 1); lcd << '_';
      break;
    }
    cw = cw_texte[cw_pos];       
//    if (cw >= 'a' and cw <= 'z') cw = cw & 0XDF; // en MAJUSCULES
    cw_pos++;
    lcd.setCursor(15, 1); lcd << cw ;
 
// caractère suivant
    if (cw == ' ') {
      tempo_cw = 7*CW_DOTLEN;
      grafcet_cw=2;
      break;
    }

// BIPs divers sous forme 'a' 'a#' 'a3' ou 'a3#'
    if (cwcw == 0 && cw >= 'a' && cw <= 'g') {
      i=0; 
      while((note_name[i]!=cw) && (i<7)){ i++; }
// gamme ?
      note_freq=note_tone[i];
      if (cw_texte[cw_pos] >= '1' && cw_texte[cw_pos] <= '9') {
        note_freq=note_freq*pow(2.,cw_texte[cw_pos]-'3');
        cw_pos++;
      }
// Dièse ?
      if (cw_texte[cw_pos] == '#') {
        note_freq=note_freq*demiton;
        cw_pos++;
      }
//      Serial << note_name[i] << " " << freq << "Hz" << endl;
      tone(sortie_gbf, note_freq);  tempo_cw = CW_DASHLEN;
      grafcet_cw=21;  
      break;
    } else {

// recherche du pattern du caractère suivant
      cwcw = 1; // c'est de la CW, pas de la musique !
      if (cw >= 'a' && cw <= 'z') cw = cw & 0XDF; // en MAJUSCULES
      for (i=0; i<CW_N_MORSE; i++) {
        if (morsetab[i].c == cw) {
          pw = morsetab[i].pat;
          grafcet_cw++;
        }        
      }
    }
  }    
  break;

// TONE du bit suivant
  case 3:
   if (tempo_cw == 0) {
    if (pw != 1) {
// TIT ou TAAH
      if (pw & 1) tempo_cw = CW_DASHLEN; else tempo_cw = CW_DOTLEN;
      tone(sortie_gbf, CW_PITCH) ;
      pw = pw / 2 ;
      grafcet_cw++;
// silence inter-caractères
    } else {
      tempo_cw = 2*CW_DOTLEN;  
      grafcet_cw=2; 
    }
   }
  break;

// silence 1 TAAH
  case 4:
//    if (tempo_cw == 0) { tempo_cw = CW_DOTLEN;  grafcet_cw=3; }
    if (tempo_cw == 0) { noTone(sortie_gbf);  tempo_cw = CW_DOTLEN;  grafcet_cw=3; }
  break;

// fin d'une note : silence très court
  case 21:
    if (tempo_cw == 0) { noTone(sortie_gbf); tempo_cw = CW_DOTLEN/8; grafcet_cw=2; }
  break;

// FIN, arrêt CW
// si grafcet_cw n'a pas une valeur correcte, on passe ici
  default: 
  case 9999:
    noTone(sortie_gbf); 
    grafcet_cw=0;  
  break;
}      // fin du "switch"
 
// FIN GRAFCET MORSE CW
//--------------------------------********************--------------------------------
switch (grafcet_frequencemetre) {
// attente
  case 1:
  break;
 case 2:
  grafcet_frequencemetre++;
  break;
 case 3:
  freq=500000.+second()*123.;
  grafcet_frequencemetre=1;
  break;

// si grafcet_a n'a pas une valeur correcte, on passe ici
  case 9999: 
  default: 
    grafcet_frequencemetre = 0; // on arrête
  break;
}
/*
// FREQUENCEMETRE INDEPENDANT
switch (grafcet_frequencemetre) {
// attente
  case 1:
  break;

// init
 case 2:
  FreqCounter::start(gatetime);  // Gate Time durée du comptage, 1er lancement
  grafcet_frequencemetre++;
  break;

// attente fin comptage non bloquant
 case 3:
  if (FreqCounter::f_ready == 1) {
    freq = (float) FreqCounter::f_freq*1000./gatetime;		// lecture fréquence

// ajustement de la durée d'échantillonage en fonction de la fréquence
// - on a besoin de 6 à 7 chiffres maxi (précision des float)
// - la fréquence maxi admissible est 8.000.000 Hz
// - on affiche finalement que 4 chiffres pour les C et L
    gatetime=100;
    if (freq < 1000000) gatetime=1000;
//    if (freq < 10000) gatetime=100;
//    if (freq < 1000) gatetime=1000;
//    FreqCounter::start(gatetime);  // Gate Time durée du comptage : multiple de 2, maxi 1000
    grafcet_frequencemetre=1;
  }
  break;

// si grafcet_a n'a pas une valeur correcte, on passe ici
  case 9999: 
  default: 
    grafcet_frequencemetre = 0; // on arrête
  break;
}      // fin du "switch"
*/
